#include <stdio.h>
#include <stdlib.h> /* pour exit */
#include <string.h> /* pour strcmp */
#include <sys/types.h>
#include <sys/socket.h>
#include <string.h> /* pour memset */
#include <netinet/in.h> /* pour struct sockaddr_in */
#include <arpa/inet.h> /* pour htons, htonl et inet_aton */
#include <netdb.h> /* pour getnameinfo */

#define PORT IPPORT_USERRESERVED // = 5000

#define LG_MESSAGE   256
#define MAX_CLIENTS  10

typedef struct _CLIENT
{
   char host[NI_MAXHOST];
   char service[NI_MAXSERV];
} CLIENT;

int trouveClient(CLIENT clients[], char host[], char service[]);
int insereNouveauClient(CLIENT clients[], char host[], char service[]);
void afficheClients(CLIENT clients[]);
int envoyeClients(CLIENT clients[], int emetteur, int sock, char message[]);

int main()
{
   int descripteurSocket;
   struct sockaddr_in pointDeRencontreLocal;
   struct sockaddr_in pointDeRencontreDistant;
   socklen_t longueurAdresse;
   char messageRecu[LG_MESSAGE]; /* le message de la couche Application ! */  
   int lus; /* nb d'octets lus */
   int retour;
   CLIENT clients[MAX_CLIENTS];
   char host[NI_MAXHOST], service[NI_MAXSERV];
   int numeroClient, nb;

   // Crée un socket de communication 
   descripteurSocket = socket(PF_INET, SOCK_DGRAM, 0);

   // Teste la valeur renvoyée par l'appel système socket()
   if(descripteurSocket < 0) /* échec ? */
   {
      perror("socket"); // Affiche le message d'erreur
      exit(-1); // On sort en indiquant un code erreur
   } 
   printf("Socket créée avec succès ! (%d)\n", descripteurSocket);

   // On prépare l'adresse d'attachement locale
   longueurAdresse = sizeof(struct sockaddr_in);
   memset(&pointDeRencontreLocal, 0x00, longueurAdresse);
   pointDeRencontreLocal.sin_family        = PF_INET;
   pointDeRencontreLocal.sin_addr.s_addr   = htonl(INADDR_ANY); // n'importe quelle interface locale disponible
   pointDeRencontreLocal.sin_port          = htons(PORT); // <- 5000

   // On demande l'attachement local de la socket
   if((bind(descripteurSocket, (struct sockaddr *)&pointDeRencontreLocal, longueurAdresse)) < 0)
   {
      perror("bind");
      exit(-2);
   }
   printf("Socket attachée avec succès !\n\n");
   
   // Initialise à 0 la structure des clients
   memset(&clients[0], 0x00, MAX_CLIENTS*sizeof(CLIENT));
   while(1)
   {
      // Initialise à 0 la structure sockaddr_in
      memset(&pointDeRencontreDistant, 0x00, longueurAdresse);
   
      // Initialise à 0 le message
      memset(messageRecu, 0x00, LG_MESSAGE*sizeof(char));
      
      // Réceptionne un message du client
      lus = recvfrom(descripteurSocket, messageRecu, sizeof(messageRecu), 0, (struct sockaddr *)&pointDeRencontreDistant, &longueurAdresse);
      switch(lus)
      {
         case -1 : /* une erreur ! */
            perror("recvfrom");
            close(descripteurSocket);
            exit(-3);
         case 0 : 
            fprintf(stderr, "Aucune donnée n'a été reçue !\n\n"); 
            close(descripteurSocket);
            return 0;
         default: /* réception de n octets */
         {
            // Récupère les informations sur le client
            retour = getnameinfo((struct sockaddr *)&pointDeRencontreDistant, longueurAdresse, host, NI_MAXHOST, service, NI_MAXSERV, NI_NUMERICSERV);
            if (retour == 0)
            {
               printf("Message : %s -> reçu du client [%s:%s]\n\n", messageRecu, host, service);
               numeroClient = trouveClient(clients, host, service);
               if(numeroClient == -1)
                     numeroClient = insereNouveauClient(clients, host, service);
               nb = envoyeClients(clients, numeroClient, descripteurSocket, messageRecu);
               if(nb > 0)
                  printf("Le message a été envoyé à %d client(s)\n\n", nb);
               afficheClients(clients);
            }
            else
               fprintf(stderr, "getnameinfo: %s\n", gai_strerror(retour));
         }
      }
   }
   
   // On ferme la ressource avant de quitter   
   close(descripteurSocket);

   return 0;
}

int trouveClient(CLIENT clients[], char host[], char service[])
{
   int i;
   int trouve = -1;
   
   // TODO
   
   return trouve;
}

int infoClient(CLIENT clients[], int numeroClient, CLIENT *client)
{
   // TODO
      
   return 0;
}

int insereNouveauClient(CLIENT clients[], char host[], char service[])
{
   int i;
   int position = -1;
   
   // TODO
   
   return position;
}

void afficheClients(CLIENT clients[])
{
   int i;
   
   printf("Liste des clients en ligne :\n");
   for(i=0;i<MAX_CLIENTS;i++)
   {
      if(strcmp(clients[i].host, "") != 0 && strcmp(clients[i].service, "") != 0)
         printf("[%s:%s]\n", clients[i].host, clients[i].service);
   }
   printf("\n");
}

int envoyeClients(CLIENT clients[], int emetteur, int sock, char message[])
{
   int i;
   int nb = 0;
   
   // TODO
   
   return nb;
}
